ModuleNotFoundError: No module named 'absl' in Python

avatar

Borislav Hadzhiev

Mon Apr 18 20224 min read

banner

Photo by Hannah Skelly

"ModuleNotFoundError: No module named 'absl' in Python" #

The Python "ModuleNotFoundError: No module named 'absl'" occurs when we forget to install the absl-py module before importing it or install it in an incorrect environment. To solve the error, install the module by running the pip install absl-py command.

no module named absl

Open your terminal in your project's root directory and install the absl-py module.

shell
# ๐Ÿ‘‡๏ธ in a virtual environment or using Python 2 pip install absl-py # ๐Ÿ‘‡๏ธ for python 3 (could also be pip3.10 depending on your version) pip3 install absl-py # ๐Ÿ‘‡๏ธ if you get permissions error sudo pip3 install absl-py # ๐Ÿ‘‡๏ธ if you don't have pip in your PATH environment variable python -m pip install absl-py # ๐Ÿ‘‡๏ธ for python 3 (could also be pip3.10 depending on your version) python3 -m pip install absl-py # ๐Ÿ‘‡๏ธ for Anaconda conda install -c anaconda absl-py

After you install the absl-py package, try importing it like:

main.py
from absl import app from absl import flags FLAGS = flags.FLAGS flags.DEFINE_string("name", None, "Your name.") flags.DEFINE_integer("num_times", 1, "Number of times to print greeting.") # Required flag. flags.mark_flag_as_required("name") def main(argv): del argv # Unused. for i in range(0, FLAGS.num_times): print('Hello, %s!' % FLAGS.name) if __name__ == '__main__': app.run(main)

The Python error "ModuleNotFoundError: No module named 'absl'" occurs for multiple reasons:

  1. Not having the absl-py package installed by running pip install absl-py.
  2. Installing the package in a different Python version than the one you're using.
  3. Installing the package globally and not in your virtual environment.
  4. Your IDE running an incorrect version of Python.
  5. Naming your module absl.py which would shadow the official module.
  6. Declaring a variable named absl which would shadow the imported variable.

If the error persists, get your Python version and make sure you are installing the package using the correct Python version.

shell
python --version

get python version

For example, my Python version is 3.10.4, so I would install the absl-py package with pip3.10 install absl-py.

shell
pip3.10 install absl-py # ๐Ÿ‘‡๏ธ if you get permissions error use pip3 (NOT pip3.X) sudo pip3 install absl-py

Notice that the version number corresponds to the version of pip I'm using.

If the PATH for pip is not set up on your machine, replace pip with python3 -m pip:

shell
# ๐Ÿ‘‡๏ธ make sure to use your version of Python, e.g. 3.10 python3 -m pip install absl-py

If the "No module named 'absl'" error persists, try restarting your IDE and development server / script.

You can check if you have the absl-py package installed by running the pip show absl-py command.

shell
# ๐Ÿ‘‡๏ธ check if you have absl-py installed pip3 show absl-py # ๐Ÿ‘‡๏ธ if you don't have pip setup in PATH python3 -m pip show absl-py

The pip show absl-py command will either state that the package is not installed or show a bunch of information about the package, including the location where the package is installed.

If the package is not installed, make sure your IDE is using the correct version of Python.

If you have multiple Python versions installed on your machine, you might have installed the absl-py package using the incorrect version or your IDE might be setup to use a different version.

For example, In VSCode, you can press CTRL + Shift + P or (โŒ˜ + Shift + P on Mac) to open the command palette.

Then type "Python select interpreter" in the field.

python select interpreter

Then select the correct python version from the drop down menu.

select correct python version

Your IDE should be using the same version of Python (including the virtual environment) that you are using to install packages from your terminal.

If you are using a virtual environment, make sure you are installing absl-py in your virtual environment and not globally.

You can try creating a virtual environment if you don't already have one.

shell
# ๐Ÿ‘‡๏ธ use correct version of Python when creating VENV python3 -m venv venv # ๐Ÿ‘‡๏ธ activate on Unix or MacOS source venv/bin/activate # ๐Ÿ‘‡๏ธ activate on Windows (cmd.exe) venv\Scripts\activate.bat # ๐Ÿ‘‡๏ธ activate on Windows (PowerShell) venv\Scripts\Activate.ps1 # ๐Ÿ‘‡๏ธ install absl-py in virtual environment pip install absl-py

Your virtual environment will use the version of Python that was used to create it.

If the error persists, make sure you haven't named a module in your project as absl.py because that would shadow the original absl-py module.

You also shouldn't be declaring a variable named absl as that would also shadow the original module.

If the error is not resolved, try to uninstall the absl-py package and then install it.

shell
# ๐Ÿ‘‡๏ธ check if you have absl-py installed pip3 show absl-py # ๐Ÿ‘‡๏ธ if you don't have pip setup in PATH python3 -m pip show absl-py # ๐Ÿ‘‡๏ธ uninstall absl-py pip3 uninstall absl-py # ๐Ÿ‘‡๏ธ if you don't have pip setup in PATH python3 -m pip uninstall absl-py # ๐Ÿ‘‡๏ธ install absl-py pip3 install absl-py # ๐Ÿ‘‡๏ธ if you don't have pip setup in PATH python3 -m pip install absl-py

Try restarting your IDE and development server / script.

You can also try to upgrade the version of the absl-py package.

shell
pip3 install absl-py --upgrade # ๐Ÿ‘‡๏ธ if you don't have pip setup in PATH python3 -m pip install absl-py --upgrade
If the error persists, I would suggest watching a quick video on how to use Virtual environments in Python.

This one is for using using virtual environments (VENV) on Windows:

This one is for using using virtual environments (VENV) on MacOS and Linux:

Use the search field on my Home Page to filter through my more than 1,000 articles.

Copyright ยฉ 2022 Borislav Hadzhiev